<?php 
// Register and load the widget
function rsframework_rstext_widget() {
    register_widget( 'rstext_widget' );
}
add_action( 'widgets_init', 'rsframework_rstext_widget' );

//Contact info Widget 
class rstext_widget extends WP_Widget {
 
   /** constructor */
   function __construct() {
    parent::__construct(
      'rstext_widget', 
      __('RS Text Widget', 'rsframework'),
      array( 'description' => __( 'Display your text', 'rsframework' ), )
    );
  }
 
    /** @see WP_Widget::widget */
    function widget($args, $instance) { 
        extract( $args );
        $image_src = '';
        $title    = apply_filters('widget_title', $instance['title']);     
        $address2  = isset($instance['address2']) ? $instance['address2'] : '' ;
        echo wp_kses_post($before_widget); 
        if ( $title )
        echo wp_kses_post($before_title . $title . $after_title); 
  
 
    if (!empty($address2)){ ?>
    <!-- Contact Info Widget -->
        <div class="contact-intros">
            <?php echo  esc_html($address2);?>
        </div>
    <?php } ?>

    <?php echo wp_kses_post($after_widget); ?>
     <?php
    }
 
    /** @see WP_Widget::update  */
    function update($new_instance, $old_instance) {   
        $instance            = $old_instance;
        $instance['title']   = strip_tags($new_instance['title']);
        $instance['address2'] = wp_kses_post($new_instance['address2']);       
        return $instance;
    }
 
    /** @see WP_Widget::form */
    function form($instance) {  
        $title   = (isset($instance['title']))? $instance['title'] : '';      
        $address2 = (isset($instance['address2']))? $instance['address2'] :'';       
        ?>      
        <p>
          <label for="<?php echo esc_attr($this->get_field_id('title')); ?>"><?php esc_html_e('Title:', 'rsframework'); ?></label> 
          <input class="widefat" id="<?php echo esc_attr($this->get_field_id('title')); ?>" name="<?php echo esc_attr($this->get_field_name('title')); ?>" type="text" value="<?php echo esc_js( $title); ?>" />
        </p> 
        
        <p>
          <label for="<?php echo esc_attr($this->get_field_id('address2')); ?>"><?php esc_html_e('Text:', 'rsframework'); ?></label>
          <textarea class="widefat" id="<?php echo esc_attr($this->get_field_id('address2')); ?>" name="<?php echo esc_attr($this->get_field_name('address2')); ?>">
               <?php echo wp_kses_post($address2); ?>
          </textarea>
        </p>       
        <?php 
    }

 
} // end class
